/******************************************************************************
 * Copyright (c) 2000-2025 Ericsson Telecom AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/org/documents/epl-2.0/EPL-2.0.html
 ******************************************************************************/
package org.eclipse.titan.designer.license;

import java.math.BigInteger;
import java.security.interfaces.DSAParams;

/**
 * This class contains the DSA public key of the TITAN license file. (p,q,g,y)
 * 
 * @author Peter Dimitrov
 */
public final class TITANDSAPublicKey implements java.security.interfaces.DSAPublicKey {

	private static final long serialVersionUID = -370413973007646542L;

	// Big-endian two's complement binary representation of p
	// p - 1024 bit prime
	static final byte[] DSA_P = { (byte) 0x0, (byte) 0x90, (byte) 0x63, (byte) 0x82, (byte) 0xae, (byte) 0x72, (byte) 0x71, (byte) 0xac,
			(byte) 0x14, (byte) 0xec, (byte) 0x9c, (byte) 0x71, (byte) 0x38, (byte) 0x9f, (byte) 0xda, (byte) 0x8d, (byte) 0x52,
			(byte) 0xbd, (byte) 0xb1, (byte) 0xa7, (byte) 0x1a, (byte) 0x19, (byte) 0xd4, (byte) 0x5f, (byte) 0xe7, (byte) 0x37,
			(byte) 0x3d, (byte) 0x44, (byte) 0xef, (byte) 0xce, (byte) 0xa1, (byte) 0x99, (byte) 0xfa, (byte) 0x85, (byte) 0xb6,
			(byte) 0x49, (byte) 0x77, (byte) 0xf1, (byte) 0x98, (byte) 0x39, (byte) 0x6b, (byte) 0x71, (byte) 0xce, (byte) 0x2,
			(byte) 0x42, (byte) 0x64, (byte) 0x4b, (byte) 0xd, (byte) 0xad, (byte) 0x83, (byte) 0xb0, (byte) 0x6b, (byte) 0x76,
			(byte) 0xba, (byte) 0xdc, (byte) 0x4f, (byte) 0xe0, (byte) 0x19, (byte) 0xf9, (byte) 0xc2, (byte) 0x79, (byte) 0x6e,
			(byte) 0xbb, (byte) 0xc, (byte) 0xab,

			(byte) 0x16, (byte) 0xae, (byte) 0xec, (byte) 0x56, (byte) 0x75, (byte) 0xff, (byte) 0x82, (byte) 0xb, (byte) 0x74,
			(byte) 0xd8, (byte) 0x96, (byte) 0x42, (byte) 0x23, (byte) 0x68, (byte) 0xf, (byte) 0xad, (byte) 0x27, (byte) 0xee,
			(byte) 0x4c, (byte) 0xbf, (byte) 0xf2, (byte) 0xd4, (byte) 0x49, (byte) 0x77, (byte) 0x8b, (byte) 0x1e, (byte) 0xf1,
			(byte) 0xdc, (byte) 0x5c, (byte) 0x4d, (byte) 0xfd, (byte) 0xa6, (byte) 0xd8, (byte) 0x5a, (byte) 0x70, (byte) 0x3f,
			(byte) 0x13, (byte) 0xd2, (byte) 0xed, (byte) 0x3f, (byte) 0x59, (byte) 0x9, (byte) 0x62, (byte) 0x2b, (byte) 0xb2,
			(byte) 0x8f, (byte) 0xcd, (byte) 0x7a, (byte) 0xa9, (byte) 0x3e, (byte) 0x6c, (byte) 0xb1, (byte) 0xe8, (byte) 0x80,
			(byte) 0x9d, (byte) 0xd2, (byte) 0x74, (byte) 0xc, (byte) 0xc8, (byte) 0xdf, (byte) 0xa, (byte) 0x40, (byte) 0xc9,
			(byte) 0xb3 };

	// Big-endian two's complement binary representation of q
	// q - 160 bit prime (same size as the output of SHA.1)
	static final byte[] DSA_Q = { (byte) 0x0, (byte) 0xa3, (byte) 0xe2, (byte) 0x23, (byte) 0x73, (byte) 0xd3, (byte) 0x8a, (byte) 0x4b,
			(byte) 0x61, (byte) 0xd0, (byte) 0x60, (byte) 0x41, (byte) 0x21, (byte) 0x41, (byte) 0x6d, (byte) 0xc4, (byte) 0xf6,
			(byte) 0x8c, (byte) 0x5c, (byte) 0x89, (byte) 0x87 };

	// Big-endian two's complement binary representation of g
	// g - 1024 bit
	static final byte[] DSA_G = { (byte) 0x0, (byte) 0x40, (byte) 0x6d, (byte) 0xfb, (byte) 0x6d, (byte) 0xb6, (byte) 0x6, (byte) 0x32,
			(byte) 0xcc, (byte) 0xf0, (byte) 0xe9, (byte) 0x84, (byte) 0x16, (byte) 0x1e, (byte) 0xe1, (byte) 0x21, (byte) 0xcd,
			(byte) 0x34, (byte) 0xe7, (byte) 0xbb, (byte) 0x6c, (byte) 0x98, (byte) 0xff, (byte) 0xa9, (byte) 0xb9, (byte) 0xae,
			(byte) 0xe4, (byte) 0x6a, (byte) 0x61, (byte) 0x51, (byte) 0xf8, (byte) 0x66, (byte) 0x83, (byte) 0xa4, (byte) 0x34,
			(byte) 0x63, (byte) 0x81, (byte) 0xc4, (byte) 0x5f, (byte) 0xee, (byte) 0x85, (byte) 0x74, (byte) 0xee, (byte) 0x2a,
			(byte) 0x63, (byte) 0x9d, (byte) 0xcf, (byte) 0x97, (byte) 0x50, (byte) 0xb8, (byte) 0x9f, (byte) 0x76, (byte) 0xd9,
			(byte) 0xe, (byte) 0x58, (byte) 0xab, (byte) 0xac, (byte) 0x2e, (byte) 0x23, (byte) 0xac, (byte) 0x95, (byte) 0xc3,
			(byte) 0xb7, (byte) 0x14, (byte) 0xd6,

			(byte) 0x69, (byte) 0xff, (byte) 0x36, (byte) 0xef, (byte) 0xa4, (byte) 0xa9, (byte) 0xe1, (byte) 0xd6, (byte) 0x7a,
			(byte) 0xfd, (byte) 0x9d, (byte) 0x68, (byte) 0x91, (byte) 0xcf, (byte) 0x2d, (byte) 0xcd, (byte) 0x98, (byte) 0xc5,
			(byte) 0xe6, (byte) 0xf4, (byte) 0x1e, (byte) 0xde, (byte) 0xf8, (byte) 0x65, (byte) 0x6b, (byte) 0xeb, (byte) 0x80,
			(byte) 0x41, (byte) 0xab, (byte) 0xc7, (byte) 0x97, (byte) 0xcb, (byte) 0xbb, (byte) 0xc5, (byte) 0x5, (byte) 0x7,
			(byte) 0x22, (byte) 0x81, (byte) 0x58, (byte) 0x63, (byte) 0xf9, (byte) 0x67, (byte) 0xd4, (byte) 0x7c, (byte) 0xb6,
			(byte) 0x21, (byte) 0x17, (byte) 0xea, (byte) 0x62, (byte) 0xe3, (byte) 0xe8, (byte) 0x3f, (byte) 0x60, (byte) 0xb1,
			(byte) 0x51, (byte) 0x51, (byte) 0x4, (byte) 0xf2, (byte) 0x6f, (byte) 0x5c, (byte) 0x47, (byte) 0x69, (byte) 0x6b,
			(byte) 0xc1 };

	// Big-endian two's complement binary representation of y
	// y - 1024 bit
	static final byte[] DSA_Y = { (byte) 0x0, (byte) 0x76, (byte) 0xe, (byte) 0xf, (byte) 0x36, (byte) 0x77, (byte) 0x6, (byte) 0x9d,
			(byte) 0xb1, (byte) 0xf1, (byte) 0x4e, (byte) 0x9a, (byte) 0x95, (byte) 0xae, (byte) 0xc9, (byte) 0x39, (byte) 0xdf,
			(byte) 0x90, (byte) 0xd3, (byte) 0x94, (byte) 0x54, (byte) 0xf8, (byte) 0xf6, (byte) 0x89, (byte) 0xc8, (byte) 0x11,
			(byte) 0x8d, (byte) 0x2e, (byte) 0x92, (byte) 0x81, (byte) 0x6b, (byte) 0x2c, (byte) 0x37, (byte) 0x4, (byte) 0x9d,
			(byte) 0x97, (byte) 0x9a, (byte) 0x43, (byte) 0xa3, (byte) 0x2e, (byte) 0xed, (byte) 0x9a, (byte) 0x99, (byte) 0xb0,
			(byte) 0xcb, (byte) 0x9f, (byte) 0x4e, (byte) 0xea, (byte) 0x4f, (byte) 0xb7, (byte) 0xd5, (byte) 0x93, (byte) 0xc0,
			(byte) 0x86, (byte) 0x1b, (byte) 0xc7, (byte) 0x97, (byte) 0x5f, (byte) 0x5, (byte) 0xb4, (byte) 0xf1, (byte) 0xf9,
			(byte) 0xd6, (byte) 0x73, (byte) 0x97,

			(byte) 0x19, (byte) 0xe3, (byte) 0xc9, (byte) 0xda, (byte) 0xfc, (byte) 0x39, (byte) 0xe0, (byte) 0x37, (byte) 0xed,
			(byte) 0x7a, (byte) 0x62, (byte) 0xcb, (byte) 0xe3, (byte) 0x17, (byte) 0x9b, (byte) 0x64, (byte) 0x3c, (byte) 0x46,
			(byte) 0x86, (byte) 0x3f, (byte) 0x32, (byte) 0xec, (byte) 0x70, (byte) 0xab, (byte) 0x5b, (byte) 0x87, (byte) 0x5a,
			(byte) 0x6e, (byte) 0xc3, (byte) 0x37, (byte) 0xeb, (byte) 0x92, (byte) 0x58, (byte) 0x6c, (byte) 0x9e, (byte) 0x25,
			(byte) 0x1f, (byte) 0x37, (byte) 0x4b, (byte) 0xcd, (byte) 0xb5, (byte) 0x22, (byte) 0x62, (byte) 0x1d, (byte) 0x1b,
			(byte) 0x1c, (byte) 0xb1, (byte) 0x5d, (byte) 0xa1, (byte) 0xef, (byte) 0x50, (byte) 0xc3, (byte) 0x75, (byte) 0xff,
			(byte) 0x2, (byte) 0x24, (byte) 0x8c, (byte) 0xd7, (byte) 0x3b, (byte) 0x91, (byte) 0x77, (byte) 0xef, (byte) 0x94,
			(byte) 0x76 };

	@Override
	public BigInteger getY() {
		return new BigInteger(DSA_Y);
	}

	@Override
	public DSAParams getParams() {
		final DSAParams params = new DSAParams() {

			@Override
			public BigInteger getG() {
				return new BigInteger(DSA_G);
			}

			@Override
			public BigInteger getP() {
				return new BigInteger(DSA_P);
			}

			@Override
			public BigInteger getQ() {
				return new BigInteger(DSA_Q);
			}
		};
		return params;

	}

	@Override
	public String getAlgorithm() {
		return "DSA";
	}

	@Override
	public byte[] getEncoded() {
		return new byte[] {};
	}

	@Override
	public String getFormat() {
		return null;
	}

}
